<template>
  <div
    v-show="isShowDropdown"
    class="ob-menu-dropdown-container"
    :class="containerClass"
  >
    <div
      v-click-outside="onClickOutside"
      class="wrapper"
      @mouseleave="trigger === 'hover' && visibleChange(false)"
    >
      <button
        ref="button"
        class="menu-button"
        :data-qa="dataQa"
        @click="trigger === 'click' && onClickButton()"
        @mouseenter="trigger === 'hover' && visibleChange(true)"
      >
        <template v-if="isLoading">
          <ObLoader
            :size="15"
          />
        </template>
        <template v-else-if="$slots.button">
          <slot name="button" />
        </template>
        <template v-else>
          <template v-if="label">
            <span class="menu-button-text">
              {{ label }}
            </span>
            <i
              v-if="isArrow"
              class="icon menu-button__arrow"
              :class="isOpened ? 'chevron-up' : 'chevron-down'"
            />
          </template>
          <template v-else>
            <i
              :class="[ 'icon', icon ]"
            />
          </template>
        </template>
      </button>
      <transition
        name="fade-dropdomn-menu"
        mode="out-in"
        @enter="checkWidth"
      >
        <div
          v-if="isOpened && !isLoading"
          ref="dropdown"
          class="menu-dropdown"
          :class="[ 'position-' + position ]"
          :style="dropdownStyles"
        >
          <ul
            class="menu-dropdown-list"
          >
            <li
              v-for="(item, index) in localItems"
              v-show="!item.isHidden"
              :key="index"
              :class="[item.className, getItemClass(item)]"
              class="menu-dropdown-list__item"
            >
              <button
                :data-qa="dataQa"
                @click.stop="handleCommand(item)"
              >
                <div class="col-left">
                  <i
                    v-if="item.icon"
                    :class="'icon ' + item.icon"
                  />
                </div>
                <div class="col-right">
                  <span class="col-right__title">{{ item.title }}</span>
                  <span
                    v-if="item.description"
                    class="col-right__description"
                  >{{ item.description }}
                  </span>
                </div>
              </button>
            </li>
          </ul>
        </div>
      </transition>
    </div>
  </div>
</template>
<script>
import ClickOutside from 'vue-click-outside'
import ObLoader from '../obLoader'

export default {
  name: 'ObMenuDropdown',
  directives: {
    ClickOutside
  },
  components: {
    ObLoader
  },
  props: {
    items: {
      type: Array,
      default: null
    },
    trigger: {
      type: String,
      default: 'click'
    },
    position: {
      type: String,
      default: 'end'
    },
    label: {
      type: String,
      default: null
    },
    icon: {
      type: String,
      default: 'more'
    },
    isArrow: {
      type: Boolean,
      default: true
    },
    isNoneButtonStyle: {
      type: Boolean,
      default: false
    },
    dataQa: {
      type: String
    },
    remoteOpt: {
      type: [Function, Object],
      default: null
    },
    parentContainerSelector: {
      type: String,
      default: null
    }
  },
  data () {
    return {
      isOpened: false,
      width: 'auto',
      whiteSpace: 'pre',
      isLoading: false,
      localItems: [],
      isTopPosition: false
    }
  },
  computed: {
    isShowDropdown () {
      return this.isRemote || (this.localItems && this.localItems.length && this.localItems.some(item => !item.isHidden))
    },
    dropdownStyles () {
      return {
        width: this.width,
        whiteSpace: this.whiteSpace
      }
    },
    containerClass () {
      return {
        '--opened': this.isOpened,
        '--list-with-icons': this.listWidthIcons,
        '--none-button-style': this.isNoneButtonStyle,
        '--is-loading': this.isLoading,
        '--is-top': this.isTopPosition
      }
    },
    listWidthIcons () {
      return this.localItems && this.localItems.length && this.localItems.find(item => item.icon)
    },
    isRemote () {
      return this.isRemoteFunction || this.isRemoteObject
    },
    isRemoteFunction () {
      return this.remoteOpt && typeof this.remoteOpt === 'function'
    },
    isRemoteObject () {
      return this.remoteOpt && typeof this.remoteOpt === 'object' && this.remoteOpt.method
    }
  },
  watch: {
    items: {
      immediate: true,
      handler (value) {
        if (value && value.length) {
          this.localItems = value
        } else {
          this.localItems = []
        }
      }
    }
  },
  methods: {
    onClickButton () {
      if (this.isLoading) {
        return false
      }

      if (this.localItems.length) {
        this.visibleToggle()
      } else {
        this.isRemote ? this.loadData() : this.visibleToggle()
      }
    },
    async loadData ({ concat = false, init = false, page, sort, search } = {}) {
      this.isLoading = true
      try {
        const promise = this.isRemoteFunction ? this.remoteOpt : this.remoteOpt.method
        const res = await promise()

        this.localItems = res
        this.$nextTick(() => {
          this.isOpened = true
        })
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        })
      } finally {
        this.$nextTick(() => {
          this.isLoading = false
        })
      }
    },
    checkWidth () {
      this.width = 'auto'
      this.isTopPosition = false
      this.$nextTick(() => {
        const dropdown = this.$refs.dropdown
        const dropdownWidth = dropdown.clientWidth
        const dropdownHeight = dropdown.clientHeight
        const buttonBound = this.$refs.button.getBoundingClientRect()
        const buttonBoundBottom = buttonBound.bottom
        const documentHeight = document.body.scrollHeight
        const scrollTop = window.pageYOffset
        let bottomSpace

        if (this.parentContainerSelector) {
          const parentContainer = this.$el.closest(this.parentContainerSelector)
          const parentContainerBound = parentContainer.getBoundingClientRect()
          bottomSpace = parentContainerBound.bottom - buttonBoundBottom - dropdownHeight
        } else {
          bottomSpace = documentHeight - scrollTop - buttonBoundBottom - dropdownHeight
        }

        this.isTopPosition = bottomSpace < 5

        if (dropdownWidth >= 400) {
          this.width = '400px'
          this.whiteSpace = 'pre-wrap'
        } else {
          this.width = dropdownWidth + 'px'
          this.whiteSpace = 'pre'
        }
      })
    },
    handleCommand (command = {}) {
      let { event, method, to, href } = command

      if (event) {
        this.$emit(event)
      }

      if (method) {
        method(command)
      }

      if (to) {
        this.$router.push({ ...to })
      }

      if (href) {
        document.location.href = href
      }

      this.visibleChange(false)
    },
    visibleToggle () {
      this.isOpened = !this.isOpened
    },
    visibleChange (visibleStatus) {
      this.isOpened = visibleStatus
    },
    onClickOutside () {
      if (this.isOpened) {
        this.isOpened = false
      }
    },
    getItemClass (item) {
      return {
        '--disabled': !!item.isDisabled,
        '--active': !!item.isSelected
      }
    }
  }
}
</script>
<style lang="scss">
@import "../../static/css/mixins";
@import "../../static/css/variables";
$transition-timing: 0.3s;
.ob-menu-dropdown-container:not(.--none-button-style) {
  .menu-button {
    display: flex;
    justify-content: center;
    align-items: center;
    min-width: 44px;
    height: 24px;
    margin: 0!important;
    padding: 0 10px !important;
    border-radius: 4px 4px 0 0;
    background: transparent;
    border: none;
    text-align: center;
    outline: none;
    cursor: pointer;
    transition: none;
    &::before, &::after {
      pointer-events: none;
      content: '';
      display: block;
      position: absolute;
    }
    &::before {
      top: -10px;
      left: 0;
      z-index: 1;
      width: 100%;
      height: 44px;
      border-radius: 4px 4px 0 0;
    }
    &::after {
      z-index: 200;
      bottom: -10px;
      left: 0;
      width: 100%;
      height: 10px;
      background-color: $background-white;
      opacity: 0;
      transition: none;
    }
    i {
      position: absolute;
      z-index: 3;
      display: inline-flex;
      color: $color-blue-navy-blue;
      font-size: 24px;
    }
    &-text {
      margin: 0 5px;
      @include font-mixin(16px, 16px, 400, $color-blue-navy-blue, 0.4px);
    }
    &__arrow {
      font-size: 24px;
    }
  }
}
.ob-menu-dropdown-container {
  position: relative;
  display: inline-block;
  .ob-form-controls-container & {
    transform: translateX(10px);
  }
  .wrapper {
    position: relative;
  }
  .menu-button {
    position: relative;
    background: transparent;
    border: none;
    outline: none;
    cursor: pointer;
    color: $color-text-base;
    .preloader {
      position: absolute;
      z-index: 1;
    }
    i {
      color: $color-blue-navy-blue;
      & + span {
        margin-left: 5px;
      }
    }
  }
  &.--is-loading {
    .menu-button {
      &::before, &::after {
        display: none !important;
      }
    }
  }
  &.--none-button-style {
    .menu-dropdown {
      border-radius: 4px!important;
    }
  }
  &.--is-top {
    .menu-button {
      &::after {
        bottom: auto;
        top: -11px;
        height: 14px;
      }
    }
    .menu-dropdown {
      bottom: calc(100% + 9px);
      top: auto!important;
    }
  }
  .menu-dropdown {
    position: absolute;
    z-index: 150;
    top: calc(100% + 9px);
    min-width: 230px;
    background-color: $background-white;
    box-shadow: 0 4px 16px rgba($color-text-base, 0.24), 0px -1px 6px rgba($color-text-base, 0.08);
    &.position {
      &-start {
        left: 0;
        border-radius: 0 4px 4px 4px;
      }
      &-end {
        right: 0;
        border-radius: 4px 0 4px 4px;
      }
    }
    &-list {
      list-style-type: none;
      margin: 0;
      padding: 8px 0;
      &__item {
        color: $color-text-base;
        &:hover {
          background-color: $lavender;
        }
        button {
          display: flex;
          justify-content: flex-start;
          align-items: flex-start;
          width: 100% !important;
          height: 100%;
          margin: 0 !important;
          padding: 8px 20px !important;
          background-color: transparent;
          border: none;
          outline: none;
          cursor: pointer;
          text-align: left;
          color: inherit;
          .col-left {
            &:not(:empty) {
              margin-right: 8px;
            }
            i {
              color: $color-grey-span;
              font-size: 24px;
              &::before {
                color: $color-grey-span;
              }
            }
          }
          .col-right {
            &__title {
              display: block;
              @include font-mixin(16px, 20px, 400);
            }
            &__description {
              display: block;
              margin-top: 5px;
              margin-left: 1px;
              @include font-mixin(12px, 12px, 400, $gray-slate, 0.4px);
            }
          }
        }
        &.--disabled {
          cursor: not-allowed;
          color: $gray-window;
          pointer-events: none;
        }
        &.--active {
          background-color: $blue-blue-hoarfrost;
        }
      }
    }
  }
  &.--opened:not(.--none-button-style) {
    .menu-button {
      &::before {
        pointer-events: all;
        opacity: 1;
        box-shadow: 0 4px 16px rgba($color-text-base, 0.24), 0px -1px 6px rgba($color-text-base, 0.08);
        background-color: $background-white;
        transition: all $transition-timing;
      }
      &:after {
        pointer-events: all;
        opacity: 1;
        transition: opacity $transition-timing, bottom 0s;
      }
    }
  }
  &.--list-with-icons {
    .menu-dropdown-list {
      padding: 10px 0;
      &__item {
        button {
          padding: 10px 20px !important;
          .col-right {
            padding-top: 3px;
          }
        }
      }
    }
  }
}
.fade-dropdomn-menu-enter-active {
  pointer-events: all;
  transition: all $transition-timing;
}
.fade-dropdomn-menu-enter, .fade-dropdomn-menu-leave-to {
  opacity: 0;
  pointer-events: none;
}
</style>
